<?php
/**
*Plugin Name: Discount based on Number of Order For WooCommerce
*Description: Using this plugin you can provide discount based on total no of previous orders done by customer in a woocommerce store
*Version: 1.0.4
*Author: extensionhawk
*Author URI: https://www.xadapter.com/
*/


//		Add Admin Menu
add_action('admin_menu', 'ehawk_add_custom_settings');


//		Assign a Function Which Parses the Admin Form
function ehawk_add_custom_settings()
{
	add_menu_page(
		'Discount by Total Number of Order',	#$page_title
		' Discount Based On Orders',		#$menu_title
		'manage_options',			#$capability
		'ehawk_ssp_order_discount',		#$menu_slug - Used in url
		'ehawk_ssp_menu_callback'		#The function to be called to output the content for this page.
		);
}

        add_filter( 'plugin_action_links_' . plugin_basename( __FILE__ ),  'plugin_action_links_orders'  ); 
         function plugin_action_links_orders( $links ) {
			$plugin_links =array( '<a href="' . admin_url( 'admin.php?page=ehawk_ssp_order_discount' ) . '">' . __( 'Settings', '') . '</a>'
                            );     
                        return array_merge( $plugin_links,$links );
        }

function ehawk_ssp_menu_callback()
{
?>
	<form method="post" action="options.php">
	<?php
		settings_fields('ehawk_ssp_order_discount');
		do_settings_sections('ehawk_ssp_order_discount');
		submit_button('Submit');
	?>
	</form>
			
<?php
}

add_action('admin_init','ehawk_ssp_register_my_setting');
//		Register a settings
function ehawk_ssp_register_my_setting()
{
	//add_settings_section( $id, $title, $callback, $page )
	add_settings_section(
		'ehawk_setting_section',
		'Discount based on total number of orders placed by specific customer',
		'ehawk_setting_section_callback',
		'ehawk_ssp_order_discount'
		);


	//add_settings_field( $id, $title, $callback, $page, $section, $args )
	add_settings_field(
		'xa_setting_field',
		'',
		'ehawk_setting_field_callback',
		'ehawk_ssp_order_discount',
		'ehawk_setting_section'
		);
	register_setting( 'ehawk_ssp_order_discount', 'ehawk_ssp_order_discount' );
}

//-----------------------------------------------------------------------------------
//					Setting Section Callback Function
//-----------------------------------------------------------------------------------
// This function is needed if we added a new section. This function will be run at the start of our section
function ehawk_setting_section_callback()
{
}

//-----------------------------------------------------------------------------------
//					Setting Field Callback Function
//-----------------------------------------------------------------------------------
function ehawk_setting_field_callback()
{
	$data=get_option('ehawk_ssp_order_discount');
	?>
	<html>
	<head>
            
	<script type="text/javascript">
 	
            function ehawk_remove_rule(rowNumber)
            {
                let divToRemove = document.getElementById("form-row#"+rowNumber);
				divToRemove.remove();        
        	return false;
            }
    
        function ehawk_add_new_rule(rap)
 	{
  	        var count = document.querySelectorAll('.form-row').length;
 		var newdiv = document.createElement('div');
                var removeButton = count >= 0 ? "<button id="+count+" onclick='return ehawk_remove_rule(this.id);' >Remove</button>" : ''; 
 		newdiv.innerHTML="<div class='form-row' id='form-row#"+count+"'>Total no. of Orders: <input type='number' min='0' name='ehawk_ssp_order_discount["+count+"][noo]' value='' required/> Discount(%): <input type='number'  step='0.00001' min='0' max='100' name='ehawk_ssp_order_discount["+count+"][disc]' value='' required/>"+removeButton+"</div>";
 		document.getElementById(rap).appendChild(newdiv);
        }            
            
	</script>
	</head>
	<body>
        <tr>	
	
	<form method="post" action="options.php"> 	<!--optios.php handles the form data its already present -->
            
		<div id = "wrap" class="cl">
		<?php
			$xa_data=get_option('ehawk_ssp_order_discount');
                        $counter=0;
		if(!empty($xa_data))
		{	foreach($xa_data as $index=>$val)
			{
		?>
				<div class='form-row' id="form-row#<?php echo $counter; ?>">
					Total no. of Orders: <input type='number' min="0" name='ehawk_ssp_order_discount[<?php echo $index; ?>][noo]' value='<?php echo $val['noo']; ?>' />
					Discount(%): <input type='number' step="0.00001" min="0" max="100" name='ehawk_ssp_order_discount[<?php echo $index; ?>][disc]' value='<?php echo $val['disc'];?>' /> 
                                      <?php 
                                      if($counter>=0)   
                                      {
                                      ?>
                                        <button id="<?php echo $counter; ?>" onclick="return ehawk_remove_rule(this.id);" > Remove </button>    
                                      <?php 
                                      }
                                      ?>
				</div>
		<?php
                 $counter++;
			}
		}
		?>
		</div>
		<input type="button" value="Add Discount" onclick="ehawk_add_new_rule('wrap');"/>
        
            </form>
        </tr>
        </body>
	</html>
<?php
echo "<hr><b>Your Discount selections were:</b></br>";

$data=get_option('ehawk_ssp_order_discount');
if(!empty($data))
{
    foreach($data as $datas)
    {
        echo "Number of orders :->".$datas['noo']. " Discount :->".$datas['disc']."</br>";
    }
    
}

}
 add_action('init','xa_check_version_order');
        function xa_check_version_order()
        {
            if(version_compare(WC()->version, '3.0.0','>='))
               {
                 add_filter('woocommerce_product_get_price','ehawk_discount_callback',1,1);
                 add_filter( 'woocommerce_format_price_range', 'change_var_price_order',999);
               }
            else
                {
                 add_filter('woocommerce_get_price','ehawk_discount_callback',1,1);
                  add_filter('woocommerce_get_price_html','change_var_price_order',999);
                  
                }
               
                
             add_filter('woocommerce_product_variation_get_price','ehawk_discount_callback',1,1);
        }
function change_var_price_order($price) {
    if ( is_user_logged_in() )
    {
	global $product;
        if ( $product->is_type( 'variable' ) )
        {
	$max_price = $product->get_variation_sale_price('max');
	$min_price = $product->get_variation_sale_price('min');
        $customer_orders = get_posts( array(
         'numberposts' => -1,
         'meta_key'    => '_customer_user',
         'meta_value'  => get_current_user_id(),
         'post_type'   => wc_get_order_types(),
         'post_status' => array_keys( wc_get_order_statuses()),)
      );
	$total_order = count($customer_orders);
	$max_disc=0;
        $z=get_option('ehawk_ssp_order_discount');
        if(!empty($z))
        {
            foreach ($z as $x)
            {
                if($total_order >= $x['noo'])
                { 
                    if($max_disc < $x['disc'])
                    {
                        $max_disc=$x['disc'];
                    }
                } 		 		 	
            }
         }
        $max_price = $max_price - ($max_disc * .01 * $max_price);
         $min_price = $min_price - ($max_disc * .01 * $min_price);
	return '<span class="woocommerce-Price-amount amount"><span class="woocommerce-Price-currencySymbol">&#36;</span>'.$min_price.'</span> &ndash; <span class="woocommerce-Price-amount amount"><span class="woocommerce-Price-currencySymbol">&#36;</span>'.$max_price.'</span>';
        }
         return $price;
}
else
{
    return $price;
}
}

function ehawk_discount_callback($price)
{
    if ( is_user_logged_in() )
    {
	$customer_orders = get_posts( array(
         'numberposts' => -1,
         'meta_key'    => '_customer_user',
         'meta_value'  => get_current_user_id(),
         'post_type'   => wc_get_order_types(),
         'post_status' => array_keys( wc_get_order_statuses()),)
      );
	$total_order = count($customer_orders);
	$max_disc=0;
    $z=get_option('ehawk_ssp_order_discount');
    if(!empty($z))
    {
    	foreach ($z as $x)
    	{
            if($total_order >= $x['noo'])
            { 
                if($max_disc < $x['disc'])
                {
                    $max_disc=$x['disc'];
                }
            } 		 		 	
     	}
     }
$price =$price - ($max_disc * .01 *$price);     
return $price;

}
 else 
{
     return $price;
}

}